#!/usr/bin/env python

import os, os.path

mypath = os.path.normpath(os.path.join(os.getcwd(), __file__))
mypath = os.path.dirname(mypath)

filename = os.path.join(mypath, 'pathtest.c')
outname  = os.path.join(mypath, 'pathtest.out')

fp = file(filename, 'w')
fp.write("""
int main(int argc, char* argv[]) {
    return 0;
}
""")
fp.close()


os.spawnvp(os.P_WAIT, 'gcc', ('gcc', '-o', outname, filename))
fp = os.popen('ldd %s' % outname, 'r')
paths = fp.readlines()
fp.close()

os.remove(filename)
os.remove(outname)

paths = [path.strip() for path in paths]

librtpath = None
libcpath  = None

for path in paths:
    if 'libc.so.6' in path:
        path = path.split('=>')
        path = path[1].strip()
        path = path.split()
        libcpath = path[0].strip()

    elif 'librt.so.1' in path:
        path = path.split('=>')
        path = path[1].strip()
        path = path.split()
        librtpath = path[0].strip()


fp = file(os.path.join(mypath, 'paths.h.tmpl'), 'r')
template = ''.join(fp.readlines())
fp.close()

fp = file(os.path.join(mypath, 'paths.h'), 'w')
fp.write(template % {'libcpath':libcpath})
fp.close()
