/**
 * chmod.c
 *
 * small test case that uses chmod()
 *
 * usage: my-chmod filename octalmode
 */

#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>

int main( int argc, char* argv[] ) {
    int mode = 0;
    int out = 0;
    char* err;

    if ( argc < 3 ) {
        char* progname = strrchr( argv[0], '/' );
        if ( NULL == progname )
            progname = argv[0];
        else
            progname++;

        fprintf( stderr, "Usage: %s filename octalmode\n", progname );
        exit( -1 );
    }


    mode = strtol( argv[2], &err, 8 );
    if ( err != argv[2] + strlen(argv[2]) )
        exit(-2);

    out = chmod( argv[1], mode );

    if ( out != 0 )
        exit(-1);

    return 0;
}
