/**
 * creat.c
 *
 * small test case that uses creat() to create a file.
 *
 * usage: my-creat filename
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>

int main( int argc, char* argv[] ) {
    int fd = 0;
    int mode = 0;
    int oldmask = 0;

    if ( argc < 2 ) {
        char* progname = strrchr( argv[0], '/' );
        if ( NULL == progname )
            progname = argv[0];
        else
            progname++;

        fprintf( stderr, "Usage: %s filename\n", progname );
        exit( -1 );
    }

    if ( argc == 3 ) {
        char* err;

        mode = strtol( argv[2], &err, 8 );
        if ( err != argv[2] + strlen(argv[2]) )
            exit(-2);

    } else {
        // mode = 0644
        mode = S_IWUSR | S_IRUSR | S_IRGRP | S_IROTH;
    }

    oldmask = umask(0);

    fd = creat( argv[1], mode );
    close( fd );

    umask( oldmask );

    return 0;
}
