/**
 * fopen.c
 *
 * small test case that uses fopen() to append to a file
 * or just read it without taking any action on it (if
 * only 2 args)
 *
 * usage: fopen filename ["string to append"]
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main( int argc, char* argv[] ) {
    FILE* fp = NULL;

    if ( argc < 2 ) {
        char* progname = strrchr( argv[0], '/' );
        if ( NULL == progname )
            progname = argv[0];
        else
            progname++;

        fprintf( stderr, "Usage: %s filename [\"string to append\"]\n", progname );
        exit( -1 );
    }

    if ( argc == 3 ) {
        fp = fopen( argv[1], "a" );
        fprintf( fp, "%s\n", argv[2] );
        fclose( fp );

    } else {
        fp = fopen( argv[1], "r" );
        fclose( fp );
    }


    return 0;
}
