/**
 * lchown.c
 *
 * small test case that uses lchown()
 *
 * usage: my-lchown linkname newowner
 */

#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <pwd.h>
#include <unistd.h>

int main( int argc, char* argv[] ) {
    int uid = -1;
    int gid = -1;
    struct passwd* pwd;

    if ( argc < 3 ) {
        char* progname = strrchr( argv[0], '/' );
        if ( NULL == progname )
            progname = argv[0];
        else
            progname++;

        fprintf( stderr, "Usage: %s linkname newowner\n", progname );
        exit( -1 );
    }

    // lookup the UID from username
    while ( NULL != (pwd = getpwent()) ) {
        if ( 0 == strcmp( argv[2], pwd->pw_name ) ) {
            uid = pwd->pw_uid;
            gid = pwd->pw_gid;
            break;
        }
    }
    endpwent();

    if ( uid == -1 )
        exit(-1);

    lchown( argv[1], uid, gid );

    return 0;
}
