/**
 * open.c
 *
 * small test case that uses open() to append to a file.
 *
 * usage: my-open filename "string to append"
 */

#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

int main( int argc, char* argv[] ) {
    int fd = 0;
    int out = 0;

    if ( argc < 3 ) {
        char* progname = strrchr( argv[0], '/' );
        if ( NULL == progname )
            progname = argv[0];
        else
            progname++;

        fprintf( stderr, "Usage: %s filename \"string to append\"\n", progname );
        exit( -1 );
    }

    fd = open( argv[1],
               O_WRONLY | O_CREAT | O_APPEND,
               S_IWUSR | S_IRUSR |
               S_IWGRP | S_IRGRP |
               S_IWOTH | S_IROTH
             );
    out = write( fd, argv[2], strlen(argv[2]) );
    if (out != strlen(argv[2]))
        exit(-1);
    write( fd, "\n", 1 );
    close( fd );

    return 0;
}
