#!/usr/bin/env python


import unittest
import os, os.path
import sys

from trackletests import *



tests = {
    'general' :unittest.makeSuite(GeneralTestCase),
    'open'    :unittest.makeSuite(OpenTestCase),
    'open64'  :unittest.makeSuite(Open64TestCase),
    'creat'   :unittest.makeSuite(CreatTestCase),
    'chown'   :unittest.makeSuite(ChownTestCase),
    'lchown'  :unittest.makeSuite(LchownTestCase),
    'chmod'   :unittest.makeSuite(ChmodTestCase),
    'unlink'  :unittest.makeSuite(UnlinkTestCase),
    'truncate':unittest.makeSuite(TruncateTestCase),
    'fopen'   :unittest.makeSuite(FopenTestCase),
    'symlink' :unittest.makeSuite(SymlinkTestCase),
    'rename'  :unittest.makeSuite(RenameTestCase),
    'link'    :unittest.makeSuite(LinkTestCase),
    'mknod'   :unittest.makeSuite(MknodTestCase)
    }

if __name__ == '__main__':
    args = sys.argv[1:]

    suite = unittest.TestSuite()

    if len(args) == 0:
        suite.addTests( tests.values() )

    else:
        for arg in args:
            if arg in tests:
                suite.addTest( tests[arg] )

    r = unittest.TextTestRunner(verbosity = 2)
    r.run(suite)

    
