<?cs include "header.cs" ?>
<?cs include "macros.cs" ?>

<div id="ctxtnav" class="nav"></div>

<div id="content" class="roadmap">

 <?cs if shellsession.index == '1' ?>
  <h1>Shell Logs</h1>
  <div>Shell session logs are grouped by ticket, and ordered so that the
  ticket with the most recent shell session is shown first. Closed tickets
  are shown after still-open tickets.
  </div>
  <div>
   <?cs var:shellsession.text ?>
  </div>
 <?cs else ?>

  <?cs if wiki.action == "edit" || wiki.action == "preview" || wiki.action == "collision" ?>
   <h1>Editing "Session <?cs var:wiki.page_name ?> (<?cs var:wiki.version ?>)"</h1><?cs
    if wiki.action == "preview" ?>
     <fieldset id="preview">
      <legend>Preview (<a href="#edit">skip</a>)</legend>
      <div class="wikipage"><?cs var:wiki.page_html ?></div>
     </fieldset><?cs
     elif wiki.action =="collision"?>
     <div class="system-message">
       Sorry, this page has been modified by somebody else since you started 
       editing. Your changes cannot be saved.
     </div><?cs
    /if ?>
   <form id="edit" action="<?cs var:wiki.current_href ?>" method="post">
    <fieldset class="iefix">
     <input type="hidden" name="action" value="edit" />
     <input type="hidden" name="version" value="<?cs var:wiki.version ?>" />
     <input type="hidden" id="scroll_bar_pos" name="scroll_bar_pos" value="<?cs
       var:wiki.scroll_bar_pos ?>" />
     <div id="rows">
      <label for="editrows">Adjust edit area height:</label>
      <select size="1" name="editrows" id="editrows" tabindex="43"
        onchange="resizeTextArea('text', this.options[selectedIndex].value)"><?cs
       loop:rows = 8, 42, 4 ?>
        <option value="<?cs var:rows ?>"<?cs
          if:rows == wiki.edit_rows ?> selected="selected"<?cs /if ?>><?cs
          var:rows ?></option><?cs
       /loop ?>
      </select>
     </div>
     <p><textarea id="text" class="wikitext" name="text" cols="80" rows="<?cs
       var:wiki.edit_rows ?>"><?cs var:wiki.page_source ?></textarea></p>
     <script type="text/javascript">
       var scrollBarPos = document.getElementById("scroll_bar_pos");
       var text = document.getElementById("text");
       addEvent(window, "load", function() {
         if (scrollBarPos.value) text.scrollTop = scrollBarPos.value;
       });
       addEvent(text, "blur", function() { scrollBarPos.value = text.scrollTop });
     </script>
    </fieldset>
    <div id="help">
     <b>Note:</b> See <a href="<?cs var:$trackle.href.wiki
?>/WikiFormatting">WikiFormatting</a> and <a href="<?cs var:$trackle.href.wiki
?>/TracWiki">TracWiki</a> for help on editing wiki content.
    </div>
    <fieldset id="diffs">
     <legend>File Diffs</legend>
     
     <?cs each:item = shellsession.diff ?>
      <div class="field">
       <input type="checkbox" id="diff-<?cs var:item.path ?>" name="diff-<?cs var:item.path ?>" value="show"<?cs
         if:item.active == 1 ?> checked="checked"<?cs /if ?> />
       <label for="diff-<?cs var:item.path ?>"><?cs var:item.path ?></label>
      </div>
     <?cs /each ?>
      
    </fieldset>
    <fieldset id="changeinfo">
     <legend>Change information</legend>
     <div class="field">
      <label>Your email or username:<br />
      <input id="author" type="text" name="author" size="30" value="<?cs
        var:wiki.author ?>" /></label>
     </div>
     <div class="field">
      <label>Comment about this change (optional):<br />
      <input id="comment" type="text" name="comment" size="60" value="<?cs
        var:wiki.comment?>" /></label>
     </div>
    </fieldset>
    <div class="buttons"><?cs
     if wiki.action == "collision" ?>
      <input type="submit" name="save" value="Submit changes" disabled="disabled" />&nbsp;
     <?cs else ?>
      <input type="submit" name="save" value="Submit changes" />&nbsp;
     <?cs /if ?>
     <input type="submit" name="cancel" value="Cancel" />
    </div>
    <script type="text/javascript" src="<?cs
      var:htdocs_location ?>js/wikitoolbar.js"></script>
   </form>
  <?cs /if ?>
  
  <?cs if wiki.action == "view" ?>
  <h1>Ticket <a href="<?cs var:trackle.href.ticket ?>/<?cs var:shellsession.ticket ?>">#<?cs var:shellsession.ticket ?></a>,
  Session <?cs var:shellsession.seq ?></h1>
        
   <div class="wikipage">
    <?cs var:shellsession.text ?>
   </div>
   <div class="buttons">
    <form method="get" action="<?cs var:wiki.current_href ?>"><div>
     <input type="hidden" name="action" value="edit" />
     <input type="submit" value="Edit this page" accesskey="e" />
    </div></form>
    
    <?cs if:len(shellsession.diff) ?>
    
    <h2 style="padding-top:1em">Files in this session</h2>

<?cs def:node_change(item,cl,kind) ?>
<?cs set:ndiffs = len(item.diff) ?>
<?cs if $ndiffs != #1 ?>
  <?cs set:diffStr = 'diffs' ?>
<?cs else ?>
  <?cs set:diffStr = 'diff' ?>
<?cs /if ?>
  <div class="<?cs var:cl ?>"></div><span><?cs var:item.path ?></span> 
  <span class="comment">(<?cs var:kind ?>)</span>
    (<?cs
     if:kind == 'deleted'
      ?><?cs if:$ndiffs > #0 ?><a href="#file<?cs var:name(item) ?>" title="Show old contents"?><?cs /if
      ?>deleted<?cs if:$ndiffs > #0 ?></a><?cs /if
      ?><?cs
     elif:kind == 'added'
      ?><?cs if:$ndiffs > #0 ?><a href="#file<?cs var:name(item) ?>" title="Show old contents"?><?cs /if
      ?>created<?cs if:$ndiffs == #0 ?>, empty<?cs /if ?><?cs if:$ndiffs > #0 ?></a><?cs /if
      ?><?cs
     elif:kind == 'modified'
      ?><?cs if:$ndiffs > #0 ?><a href="#file<?cs var:name(item) ?>" title="Show changes"><?cs /if
      ?><?cs var:ndiffs ?> <?cs var:diffStr ?><?cs if:$ndiffs > #0 ?></a><?cs /if
      ?><?cs
     elif:kind == 'temporary'
      ?>temporary<?cs
     /if ?>)
<?cs /def ?>

<dl id="overview">
 <dt class="files">Files:</dt>
 <dd class="files">
  <ul><?cs each:item = shellsession.diff ?>
   <li><?cs
    if:item.change == 'added' ?><?cs
     call:node_change(item, 'add', 'added') ?><?cs
    elif:item.change == 'deleted' ?><?cs
     call:node_change(item, 'rem', 'deleted') ?><?cs
    elif:item.change == 'modified' ?><?cs
     call:node_change(item, 'mod', 'modified') ?><?cs
    elif:item.change == 'temporary' ?><?cs
     call:node_change(item, 'tmp', 'temporary') ?><?cs
    /if ?>
   </li>
  <?cs /each ?></ul>
 </dd>
</dl>

     <div class="diff">
      <div id="legend">
       <dl>
        <!-- <dt class="unmod"></dt><dd>Unmodified</dd> -->
        <dt class="add"></dt><dd>Created</dd>
        <dt class="rem"></dt><dd>Removed</dd>
        <dt class="mod"></dt><dd>Modified</dd>
        <dt class="tmp"></dt><dd>Temporary</dd>
       </dl>
      </div>
      <ul class="entries"><?cs
      each:item = shellsession.diff ?><?cs
       if:len(item.diff) || len(item.props) ?><li class="entry" id="file<?cs
        var:name(item) ?>"><h2><?cs var:item.path ?></h2>
        <div style="padding-left:2em;padding-bottom:0.75em">Showing <?cs var:item.context ?> lines around each change. Show <a href="?action=context&key=<?cs var:item.sessionkey ?>&change=more">more</a> or <a href="?action=context&key=<?cs var:item.sessionkey ?>&change=less">fewer</a>.</div><?cs
        if:len(item.diff) ?><table class="<?cs
         var:diff.style ?>" summary="Differences" cellspacing="0"><?cs
         if:diff.style == 'sidebyside' ?>
          <colgroup class="l"><col class="lineno" /><col class="content" /></colgroup>
          <colgroup class="r"><col class="lineno" /><col class="content" /></colgroup>
          <thead><tr>
           <th colspan="2"><a href="<?cs
            var:item.browser_href.old ?>" title="Show old rev. <?cs
            var:item.rev.old ?> of <?cs var:item.path.old ?>">Revision <?cs
            var:item.rev.old ?></a></th>
           <th colspan="2"><a href="<?cs
            var:item.browser_href.new ?>" title="Show new rev. <?cs
            var:item.rev.new ?> of <?cs var:item.path.new ?>">Revision <?cs
            var:item.rev.new ?></a></th>
           </tr>
          </thead><?cs
          each:change = item.diff ?><tbody><?cs
           call:diff_display(change, diff.style) ?></tbody><?cs
           if:name(change) < len(item.diff) - 1 ?><tbody class="skipped"><tr>
            <th>&hellip;</th><td>&nbsp;</td><th>&hellip;</th><td>&nbsp;</td>
           </tr></tbody><?cs /if ?><?cs
          /each ?><?cs
         else ?>
          <colgroup><col class="lineno" /><col class="lineno" /><col class="content" /></colgroup>
          <thead><tr>
           <th title="Start">Start</th>
           <th title="Finish">Finish</th>
           <th>&nbsp;</th></tr>
          </thead><?cs
          each:change = item.diff ?><?cs
           call:diff_display(change, diff.style) ?><?cs
           if:name(change) < len(item.diff) - 1 ?><tbody class="skipped"><tr>
            <th>&hellip;</th><th>&hellip;</th><td>&nbsp;</td>
           </tr></tbody><?cs /if ?><?cs
          /each ?><?cs
         /if ?></table><?cs
        /if ?></li><?cs
       /if ?><?cs
      /each ?></ul>
     </div>

     <?cs /if ?>
     
  <?cs /if ?>

 <?cs /if ?>

</div>

<?cs include "footer.cs" ?>
