from trackle.db.api import  _parse_db_str

import unittest


class ParseConnectionStringTestCase(unittest.TestCase):

    def test_postgres_simple(self):
        self.assertEqual(('postgres', {'host': 'localhost', 'path': '/trac'}),
                         _parse_db_str('postgres://localhost/trac'))

    def test_postgres_with_port(self):
        self.assertEqual(('postgres', {'host': 'localhost', 'port': 9431,
                                       'path': '/trac'}),
                         _parse_db_str('postgres://localhost:9431/trac'))

    def test_postgres_with_creds(self):
        self.assertEqual(('postgres', {'user': 'john', 'password': 'letmein',
                                       'host': 'localhost', 'port': 9431,
                                       'path': '/trac'}),
                         _parse_db_str('postgres://john:letmein@localhost:9431/trac'))


def suite():
    return unittest.makeSuite(ParseConnectionStringTestCase,'test')

if __name__ == '__main__':
    unittest.main()
