from trackle.db import Table, Column, Index, DatabaseManager

def do_upgrade(env, ver, cursor):

    db_connector, _ = DatabaseManager(env)._get_connector()

    ticket_new = Table('ticket_new', key='id')[
        Column('id', auto_increment=True),
        Column('locked'),
        Column('public', type='int'),
        Column('type'),
        Column('time', type='int'),
        Column('changetime', type='int'),
        Column('component'),
        Column('severity'),
        Column('priority'),
        Column('owner'),
        Column('reporter'),
        Column('cc'),
        Column('version'),
        Column('milestone'),
        Column('status'),
        Column('resolution'),
        Column('summary'),
        Column('description'),
        Column('keywords'),
        Index(['time']),
        Index(['status'])]

    # run the table DDL
    for stmt in db_connector.to_sql(ticket_new):
        cursor.execute(stmt)

    cursor.execute("INSERT INTO ticket_new (id, locked, public, type, time, changetime, component, severity, priority, owner, reporter, cc, version, milestone, status, resolution, summary, description, keywords) "
                   "     SELECT             id, locked, 1,      type, time, changetime, component, severity, priority, owner, reporter, cc, version, milestone, status, resolution, summary, description, keywords "
                   "       FROM ticket ")

    
    cursor.execute("DROP TABLE ticket")
    cursor.execute("ALTER TABLE ticket_new RENAME TO ticket")

