"""If the wiki page FortuneCookies exists, this macro will randomly pull
one of the bulleted items out of that page and include it here."""

from trackle.wiki.model import WikiPage
from trackle.wiki.formatter import wiki_to_html
import random

def execute(hdf, txt, env):
    cookies = WikiPage(env, name='FortuneCookies')

    text = cookies.text.splitlines()
    
    fortunes = [line[2:].strip() for line in text if line[:2] == ' *']
        
    # args will be null if the macro is called without parentesis.
    # args = txt or 'No arguments'

    return wiki_to_html( fortunes[random.randint(0, len(fortunes) - 1)], env, None )
